type stp = Base of string | Prop | Ar of (stp * stp)

type trm =
    Name of string * stp
  | False | Imp | Forall of stp | Eq of stp | Choice of stp
  | True | Neg | Or | And | Iff | Exists of stp (*** These are normalized away. ***)
  | DB of int * stp
  | Lam of stp * trm
  | Ap of trm * trm

val varint_binout : out_channel -> int -> unit
val string_binout : out_channel -> string -> unit
val stp_binout : out_channel -> stp -> unit
val trm_binout : out_channel -> trm -> unit
val varint_binin : in_channel -> int
val string_binin : in_channel -> string
val stp_binin : in_channel -> stp
val trm_binin : in_channel -> trm

val stp_str : stp -> string
val trm_str : trm -> string
val trm_ocaml_match : trm -> string
